#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), cnt = opt<int>("cnt"), d = opt<int>("d") / 2;
    int len = n / 2 / cnt;
    char let = has_opt("let") ? opt<string>("let")[0] : 'z';

    vector<string> words;
    string res;
    while (res.size() + max(1, len - d) <= n / 2) {
        int l = rnd.next(max(1, len - d), min(len + d, n / 2 - (int) res.size()));
        string word = rnd.next(format("[a-%c]{%d}", let, l));
        res += word;
        words.push_back(word);
    }

    reverse(words.begin(), words.end());
    for (auto const &w: words) res += w;

    println(res);

}